commit 27ff068babbd3a784f67ca29e7f46542d22ca524
Author: Patrick Plitzner <p.plitzner@bgbm.org>
Date:   Mon Feb 12 15:21:55 2018 +0100

    ref #6902 Convert part descriptors to parts

diff --git a/eu.etaxonomy.taxeditor.molecular/fragment.e4xmi b/eu.etaxonomy.taxeditor.molecular/fragment.e4xmi
index 4336378b0..a3abcc762 100644
--- a/eu.etaxonomy.taxeditor.molecular/fragment.e4xmi
+++ b/eu.etaxonomy.taxeditor.molecular/fragment.e4xmi
@@ -30,24 +30,8 @@
     <elements xsi:type="menu:HandledMenuItem" xmi:id="_xftzgH22EeeVL5aZ55YsWA" elementId="eu.etaxonomy.taxeditor.molecular.handledmenuitem.commandnameshow_pherogram" label="%command.name.SHOW_PHEROGRAM" command="_m9gZAH22EeeVL5aZ55YsWA"/>
   </fragments>
   <fragments xsi:type="fragment:StringModelFragment" xmi:id="_paaYIKT5Eeejf7ggYkp-TA" featurename="descriptors" parentElementId="xpath:/">
-    <elements xsi:type="basic:PartDescriptor" xmi:id="_sAK5cKT5Eeejf7ggYkp-TA" elementId="eu.etaxonomy.taxeditor.molecular.editor.e4.AlignmentEditorE4" label="%editor.ALIGNMENT_EDITOR" closeable="true" dirtyable="true" contributionURI="bundleclass://eu.etaxonomy.taxeditor.molecular/eu.etaxonomy.taxeditor.molecular.editor.e4.AlignmentEditorE4">
-      <handlers xmi:id="_8S4OwKUAEeejf7ggYkp-TA" elementId="eu.etaxonomy.taxeditor.molecular.editor.e4.handler.UpdateConsensusSequenceHandlerE4" contributionURI="bundleclass://eu.etaxonomy.taxeditor.molecular/eu.etaxonomy.taxeditor.molecular.editor.e4.handler.UpdateConsensusSequenceHandlerE4" command="_gnsTYKT7Eeejf7ggYkp-TA"/>
-      <handlers xmi:id="__mR5MKUAEeejf7ggYkp-TA" elementId="eu.etaxonomy.taxeditor.molecular.editor.e4.handler.CreateConsensusSequenceHandlerE4" contributionURI="bundleclass://eu.etaxonomy.taxeditor.molecular/eu.etaxonomy.taxeditor.molecular.editor.e4.handler.CreateConsensusSequenceHandlerE4" command="_d28DAKT7Eeejf7ggYkp-TA"/>
-      <handlers xmi:id="_DD3aYKUBEeejf7ggYkp-TA" elementId="eu.etaxonomy.taxeditor.molecular.editor.e4.handler.ReverseComplementHandlerE4" contributionURI="bundleclass://eu.etaxonomy.taxeditor.molecular/eu.etaxonomy.taxeditor.molecular.editor.e4.handler.ReverseComplementHandlerE4" command="_cnIoAKT7Eeejf7ggYkp-TA"/>
-      <handlers xmi:id="_FoONgKUBEeejf7ggYkp-TA" elementId="eu.etaxonomy.taxeditor.molecular.editor.e4.handler.CutPherogramRightHandlerE4" contributionURI="bundleclass://eu.etaxonomy.taxeditor.molecular/eu.etaxonomy.taxeditor.molecular.editor.e4.handler.CutPherogramRightHandlerE4" command="_akezwKT7Eeejf7ggYkp-TA"/>
-      <handlers xmi:id="_I78oEKUBEeejf7ggYkp-TA" elementId="eu.etaxonomy.taxeditor.molecular.editor.e4.handler.CutPherogramLeftHandlerE4" contributionURI="bundleclass://eu.etaxonomy.taxeditor.molecular/eu.etaxonomy.taxeditor.molecular.editor.e4.handler.CutPherogramLeftHandlerE4" command="_YLPrgKT7Eeejf7ggYkp-TA"/>
-      <handlers xmi:id="_NLSWUKUBEeejf7ggYkp-TA" elementId="eu.etaxonomy.taxeditor.molecular.editor.e4.handler.ToggleLeftRightInsertionHandlerE4" contributionURI="bundleclass://eu.etaxonomy.taxeditor.molecular/eu.etaxonomy.taxeditor.molecular.editor.e4.handler.ToggleLeftRightInsertionHandlerE4" command="_rz8wcKT7Eeejf7ggYkp-TA"/>
-      <handlers xmi:id="_WV0zQKUBEeejf7ggYkp-TA" elementId="eu.etaxonomy.taxeditor.molecular.editor.e4.handler.ToggleInsertOverwriteHandlerE4" contributionURI="bundleclass://eu.etaxonomy.taxeditor.molecular/eu.etaxonomy.taxeditor.molecular.editor.e4.handler.ToggleInsertOverwriteHandlerE4" command="_pfKDUKT7Eeejf7ggYkp-TA"/>
-      <handlers xmi:id="_ar1KMKUBEeejf7ggYkp-TA" elementId="eu.etaxonomy.taxeditor.molecular.editor.e4.handler.LoadPherogramHandlerE4" contributionURI="bundleclass://eu.etaxonomy.taxeditor.molecular/eu.etaxonomy.taxeditor.molecular.editor.e4.handler.LoadPherogramHandlerE4" command="_ncVP8KT7Eeejf7ggYkp-TA"/>
-      <handlers xmi:id="_myRFoKUDEeejf7ggYkp-TA" elementId="eu.etaxonomy.taxeditor.molecular.editor.e4.handler.AlignmentEditorCutHandlerE4" contributionURI="bundleclass://eu.etaxonomy.taxeditor.molecular/eu.etaxonomy.taxeditor.molecular.editor.e4.handler.AlignmentEditorCutHandlerE4" command="_rlhZQKUDEeejf7ggYkp-TA"/>
-      <handlers xmi:id="_vvnbIKUDEeejf7ggYkp-TA" elementId="eu.etaxonomy.taxeditor.molecular.editor.e4.handler.AlignmentEditorCopyHandlerE4" contributionURI="bundleclass://eu.etaxonomy.taxeditor.molecular/eu.etaxonomy.taxeditor.molecular.editor.e4.handler.AlignmentEditorCopyHandlerE4" command="_q2vnsKUDEeejf7ggYkp-TA"/>
-      <handlers xmi:id="_x70M8KUDEeejf7ggYkp-TA" elementId="eu.etaxonomy.taxeditor.molecular.editor.e4.handler.AlignmentEditorPasteHandlerE4" contributionURI="bundleclass://eu.etaxonomy.taxeditor.molecular/eu.etaxonomy.taxeditor.molecular.editor.e4.handler.AlignmentEditorPasteHandlerE4" command="_tLkxEKUDEeejf7ggYkp-TA"/>
-    </elements>
-    <elements xsi:type="basic:PartDescriptor" xmi:id="_v8GjgKT5Eeejf7ggYkp-TA" elementId="eu.etaxonomy.taxeditor.molecular.editor.e4.PherogramPartE4" label="%view.PHEROGRAM_VIEW" allowMultiple="true" closeable="true" contributionURI="bundleclass://eu.etaxonomy.taxeditor.molecular/eu.etaxonomy.taxeditor.molecular.editor.e4.PherogramPartE4">
-      <handlers xmi:id="_6ioEAKT-Eeejf7ggYkp-TA" elementId="eu.etaxonomy.taxeditor.molecular.editor.e4.handler.ToggleShowPherogramProbabilitiesHandlerE4" contributionURI="bundleclass://eu.etaxonomy.taxeditor.molecular/eu.etaxonomy.taxeditor.molecular.editor.e4.handler.ToggleShowPherogramProbabilitiesHandlerE4" command="_h1lC0KT7Eeejf7ggYkp-TA"/>
-      <handlers xmi:id="_-IewYKT-Eeejf7ggYkp-TA" elementId="eu.etaxonomy.taxeditor.molecular.editor.e4.handler.ToggleShowPherogramBaseCallLinesHandlerE4" contributionURI="bundleclass://eu.etaxonomy.taxeditor.molecular/eu.etaxonomy.taxeditor.molecular.editor.e4.handler.ToggleShowPherogramBaseCallLinesHandlerE4" command="_j-w84KT7Eeejf7ggYkp-TA"/>
-      <handlers xmi:id="_36J7AKUAEeejf7ggYkp-TA" elementId="eu.etaxonomy.taxeditor.molecular.editor.e4.handler.ChangePherogramQualityOutputTypeE4" contributionURI="bundleclass://eu.etaxonomy.taxeditor.molecular/eu.etaxonomy.taxeditor.molecular.editor.e4.handler.ChangePherogramQualityOutputTypeE4" command="_lyJmEKT7Eeejf7ggYkp-TA"/>
-    </elements>
+    <elements xsi:type="basic:PartDescriptor" xmi:id="_sAK5cKT5Eeejf7ggYkp-TA" elementId="eu.etaxonomy.taxeditor.molecular.editor.e4.AlignmentEditorE4" label="%editor.ALIGNMENT_EDITOR" closeable="true" dirtyable="true" contributionURI="bundleclass://eu.etaxonomy.taxeditor.molecular/eu.etaxonomy.taxeditor.molecular.editor.e4.AlignmentEditorE4"/>
+    <elements xsi:type="basic:PartDescriptor" xmi:id="_v8GjgKT5Eeejf7ggYkp-TA" elementId="eu.etaxonomy.taxeditor.molecular.editor.e4.PherogramPartE4" label="%view.PHEROGRAM_VIEW" allowMultiple="true" closeable="true" contributionURI="bundleclass://eu.etaxonomy.taxeditor.molecular/eu.etaxonomy.taxeditor.molecular.editor.e4.PherogramPartE4"/>
   </fragments>
   <fragments xsi:type="fragment:StringModelFragment" xmi:id="_1hS_gKT7Eeejf7ggYkp-TA" featurename="children" parentElementId="eu.etaxonomy.taxeditor.workbench.menu">
     <elements xsi:type="menu:Menu" xmi:id="_nWX8cKT8Eeejf7ggYkp-TA" elementId="eu.etaxonomy.taxeditor.molecular.menu.editoralignment_editor" label="%editor.ALIGNMENT_EDITOR">
@@ -71,5 +55,10 @@
   </fragments>
   <fragments xsi:type="fragment:StringModelFragment" xmi:id="_wnXPAMuxEeeIUZ_CoTN6NQ" featurename="sharedElements" parentElementId="eu.etaxonomy.taxeditor.application.trimmedwindow.edittaxonomiceditor">
     <elements xsi:type="basic_1:Part" xmi:id="_zdV9oMuxEeeIUZ_CoTN6NQ" elementId="eu.etaxonomy.taxeditor.molecular.editor.e4.AlignmentEditorE4" contributionURI="bundleclass://eu.etaxonomy.taxeditor.molecular/eu.etaxonomy.taxeditor.molecular.editor.e4.AlignmentEditorE4" label="%editor.ALIGNMENT_EDITOR" closeable="true"/>
+    <elements xsi:type="basic_1:Part" xmi:id="_6q4gMA_-Eeii_fOfA64AYQ" elementId="eu.etaxonomy.taxeditor.molecular.editor.e4.PherogramPartE4" contributionURI="bundleclass://eu.etaxonomy.taxeditor.molecular/eu.etaxonomy.taxeditor.molecular.editor.e4.PherogramPartE4" label="%view.PHEROGRAM_VIEW" closeable="true">
+      <handlers xmi:id="_6ioEAKT-Eeejf7ggYkp-TA" elementId="eu.etaxonomy.taxeditor.molecular.editor.e4.handler.ToggleShowPherogramProbabilitiesHandlerE4" contributionURI="bundleclass://eu.etaxonomy.taxeditor.molecular/eu.etaxonomy.taxeditor.molecular.editor.e4.handler.ToggleShowPherogramProbabilitiesHandlerE4" command="_h1lC0KT7Eeejf7ggYkp-TA"/>
+      <handlers xmi:id="_-IewYKT-Eeejf7ggYkp-TA" elementId="eu.etaxonomy.taxeditor.molecular.editor.e4.handler.ToggleShowPherogramBaseCallLinesHandlerE4" contributionURI="bundleclass://eu.etaxonomy.taxeditor.molecular/eu.etaxonomy.taxeditor.molecular.editor.e4.handler.ToggleShowPherogramBaseCallLinesHandlerE4" command="_j-w84KT7Eeejf7ggYkp-TA"/>
+      <handlers xmi:id="_36J7AKUAEeejf7ggYkp-TA" elementId="eu.etaxonomy.taxeditor.molecular.editor.e4.handler.ChangePherogramQualityOutputTypeE4" contributionURI="bundleclass://eu.etaxonomy.taxeditor.molecular/eu.etaxonomy.taxeditor.molecular.editor.e4.handler.ChangePherogramQualityOutputTypeE4" command="_lyJmEKT7Eeejf7ggYkp-TA"/>
+    </elements>
   </fragments>
 </fragment:ModelFragments>