commit f6db28c46bb2efccbaec19ecc7f8920dc0bdc52e
Author: Andreas Müller <a.mueller@bgbm.org>
Date:   Thu Oct 13 16:09:37 2016 +0200

    cleanup

diff --git a/src/main/java/eu/etaxonomy/cdm/vaadin/model/DbTableDTO.java b/src/main/java/eu/etaxonomy/cdm/vaadin/model/DbTableDTO.java
index 156b5e8c..22a1341d 100644
--- a/src/main/java/eu/etaxonomy/cdm/vaadin/model/DbTableDTO.java
+++ b/src/main/java/eu/etaxonomy/cdm/vaadin/model/DbTableDTO.java
@@ -1,15 +1,9 @@
 package eu.etaxonomy.cdm.vaadin.model;
 
 import java.io.Serializable;
-import java.util.Collection;
-import java.util.List;
-import java.util.Map;
 import java.util.UUID;
 
 import eu.etaxonomy.cdm.model.common.CdmBase;
-import eu.etaxonomy.cdm.model.description.DescriptionElementBase;
-import eu.etaxonomy.cdm.model.description.Distribution;
-import eu.etaxonomy.cdm.model.description.PresenceAbsenceTerm;
 import eu.etaxonomy.cdm.model.name.Rank;
 import eu.etaxonomy.cdm.model.name.TaxonNameBase;
 import eu.etaxonomy.cdm.model.taxon.Taxon;
@@ -32,14 +26,14 @@ public class DbTableDTO implements Serializable {
 
 	private DistributionDTO dDTO;
 
-	
+
 
 	public DbTableDTO(Taxon taxon){
 		this.taxon = CdmBase.deproxy(taxon, Taxon.class);
 	}
 
 	//----Getter - Setter - methods ----//
-	
+
 	public DistributionDTO getdDTO() {
 		return dDTO;
 	}
@@ -49,7 +43,7 @@ public class DbTableDTO implements Serializable {
 	}
 
 	/**
-	 * 
+	 *
 	 * @return
 	 */
 	public String getFullTitleCache() {
@@ -61,7 +55,7 @@ public class DbTableDTO implements Serializable {
 		return name.getFullTitleCache();
 	}
 	/**
-	 * 
+	 *
 	 * @param fullTitleCache
 	 */
 	public void setFullTitleCache(String fullTitleCache) {
@@ -93,7 +87,7 @@ public class DbTableDTO implements Serializable {
 		taxon.getName().setRank(rank);
 	}
 	/**
-	 * 
+	 *
 	 * @return
 	 */
 
@@ -103,7 +97,7 @@ public class DbTableDTO implements Serializable {
 	//----------- Detail View ------------------//
 
 	/**
-	 * 
+	 *
 	 * @return
 	 */
 	public String getTaxonNameCache(){
@@ -114,14 +108,14 @@ public class DbTableDTO implements Serializable {
 		taxon.getName().setTitleCache(titlecache, true);
 	}
 	/**
-	 * 
+	 *
 	 * @return
 	 */
 	public String getNomenclaturalCode(){
 		return taxon.getName().getNomenclaturalCode().getTitleCache();
 	}
 	/**
-	 * 
+	 *
 	 * @return
 	 */
 	public String getSecundum(){
diff --git a/src/main/webapp/VAADIN/themes/edit/addons.scss b/src/main/webapp/VAADIN/themes/edit/addons.scss
index 98607974..16573d6a 100644
--- a/src/main/webapp/VAADIN/themes/edit/addons.scss
+++ b/src/main/webapp/VAADIN/themes/edit/addons.scss
@@ -1,12 +1,12 @@
-/* This file is automatically managed and will be overwritten from time to time. */
-/* Do not manually edit this file. */
-
-/* Provided by contextmenu-4.5.jar */
+/* This file is automatically managed and will be overwritten from time to time. */
+/* Do not manually edit this file. */
+
+/* Provided by contextmenu-4.5.jar */
 @import "../../../VAADIN/themes/contextmenu/contextmenu.scss";
-
-
-/* Import and include this mixin into your project theme to include the addon themes */
-@mixin addons {
-	@include contextmenu;
-}
-
+
+
+/* Import and include this mixin into your project theme to include the addon themes */
+@mixin addons {
+	@include contextmenu;
+}
+
diff --git a/src/main/webapp/VAADIN/themes/macosx/addons.scss b/src/main/webapp/VAADIN/themes/macosx/addons.scss
index 98607974..16573d6a 100644
--- a/src/main/webapp/VAADIN/themes/macosx/addons.scss
+++ b/src/main/webapp/VAADIN/themes/macosx/addons.scss
@@ -1,12 +1,12 @@
-/* This file is automatically managed and will be overwritten from time to time. */
-/* Do not manually edit this file. */
-
-/* Provided by contextmenu-4.5.jar */
+/* This file is automatically managed and will be overwritten from time to time. */
+/* Do not manually edit this file. */
+
+/* Provided by contextmenu-4.5.jar */
 @import "../../../VAADIN/themes/contextmenu/contextmenu.scss";
-
-
-/* Import and include this mixin into your project theme to include the addon themes */
-@mixin addons {
-	@include contextmenu;
-}
-
+
+
+/* Import and include this mixin into your project theme to include the addon themes */
+@mixin addons {
+	@include contextmenu;
+}
+